// NavigationBar.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "TeXnicCenter.h"
#include "NavigationBar.h"

#include "global.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


#define BAR_BORDER	7
/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CNavigationBar 


CNavigationBar::CNavigationBar()
{
}


BEGIN_MESSAGE_MAP(CNavigationBar, CDialogResizeBar)
	//{{AFX_MSG_MAP(CNavigationBar)
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


BOOL CNavigationBar::OnPostCreate()
{
	CDialogResizeBar::OnPostCreate();

	CWnd		*pWnd = GetDlgItem( IDC_CATEGORYTAB );

	IFNOT( pWnd && IsWindow( pWnd->m_hWnd ) )
		return FALSE;

	if( !m_wndPropertySheet.SubclassWindow( pWnd->m_hWnd ) )
		return FALSE;

	// Treeviews initialisieren
	CRect		parentRect;

	m_wndPropertySheet.MoveWindow( CalcInnerRect() );
	m_wndPropertySheet.GetWindowRect( parentRect );
	m_wndPropertySheet.AdjustRect( FALSE, parentRect );

	m_wndEnvironmentView.Create( 
		WS_CHILD | WS_VISIBLE |
		TVS_HASLINES | TVS_LINESATROOT | TVS_HASBUTTONS | TVS_SHOWSELALWAYS,
		parentRect, &m_wndPropertySheet, 0 );
	m_wndEnvironmentView.ModifyStyleEx( 0, WS_EX_CLIENTEDGE );

	m_wndFileView.Create( 
		WS_CHILD | WS_VISIBLE |
		TVS_HASLINES | TVS_LINESATROOT | TVS_HASBUTTONS | TVS_SHOWSELALWAYS,
		parentRect, &m_wndPropertySheet, 0 );
	m_wndFileView.ModifyStyleEx( 0, WS_EX_CLIENTEDGE );
	
	m_wndStructureView.Create( 
		WS_CHILD | WS_VISIBLE | WS_BORDER | 
		TVS_HASLINES | TVS_LINESATROOT | TVS_HASBUTTONS | TVS_SHOWSELALWAYS,
		parentRect, &m_wndPropertySheet, 0 );
	m_wndStructureView.ModifyStyleEx( 0, WS_EX_CLIENTEDGE );

	// Tab-Ctrl initialisieren
	if( !m_tabImageList.Create( IDB_NAVIGATIONTAB, 16, 0, RGB( 0, 0x80, 0x80 ) ) )
		return FALSE;

	m_wndPropertySheet.SetImageList( &m_tabImageList );
	m_wndPropertySheet.AddPage( &m_wndStructureView, AfxLoadString( STE_TAB_STRUCTURE ), 0 );
	m_wndPropertySheet.AddPage( &m_wndEnvironmentView, AfxLoadString( STE_TAB_ENVIRONMENTS ), 1 );
	m_wndPropertySheet.AddPage( &m_wndFileView, AfxLoadString( STE_TAB_FILES ), 2 );

	return TRUE;
}


void CNavigationBar::OnSize(UINT nType, int cx, int cy) 
{
	CDialogResizeBar::OnSize(nType, cx, cy);

	// Gre des TabCtrls anpassen
	if( IsWindow( m_wndPropertySheet.m_hWnd ) )
		m_wndPropertySheet.MoveWindow( CalcInnerRect( BAR_BORDER ) );
}
